#import "AppDelegate.h"
#import "SamplesView.h"

using namespace HPS;

@implementation AppDelegate

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    NSArray *arguments = [[NSProcessInfo processInfo] arguments];
    std::vector<char const *> argumentVector;
    
    for (NSString * arg in arguments)
    {
        argumentVector.push_back([arg UTF8String]);
    }

    sample = new Sample();
    
    SamplesView * view = (SamplesView*)[[self window] contentView];
    view->samples = sample;
    
    HPS::ApplicationWindowOptionsKit kit;
    kit.SetAntiAliasCapable(false);
    kit.SetDriver(HPS::Window::Driver::OpenGL2);
    sample->wk = Database::CreateApplicationWindow(reinterpret_cast<WindowHandle>(view), kit);
    view->key = sample->wk;
    
    NSString * curDir = [[NSFileManager defaultManager] currentDirectoryPath];
    NSString * bundleDir = [[NSBundle mainBundle]bundlePath];
    
    NSString * samples_path = [bundleDir stringByAppendingPathComponent:@"../../../samples/data"];

    if ([[NSFileManager defaultManager] fileExistsAtPath:samples_path isDirectory:nil] == NO) {
        
        samples_path = [curDir stringByAppendingPathComponent:@"../../samples/data"];
        
        if ([[NSFileManager defaultManager] fileExistsAtPath:samples_path isDirectory:nil] == NO) {
            // please set your working directory
        }
    }
    
    sample->INPUT_FOLDER = [samples_path UTF8String];
    sample->OUTPUT_FOLDER = sample->INPUT_FOLDER;
    
}

- (BOOL)applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)theApplication {
    if(sample)
        delete sample;
    return YES;
}

@end
