#ifndef __hps_samples_osx__SamplesOSX__
#define __hps_samples_osx__SamplesOSX__

#include <iostream>
#include "hps.h"
#include "sprk.h"

using namespace HPS;

extern World * _world;

/* forward declaration */
class Test;

class Sample
{
public:
    Sample();
    ~Sample();
    void RunTest(Test * testToRun);
    
    Test * testToRun;
    UTF8 INPUT_FOLDER;
    UTF8 OUTPUT_FOLDER;
    ApplicationWindowKey wk;
    Canvas canvas;
    View view;
    Model model;
    
    //HPS SAMPLES
	void Lightweight_Subwindow(WindowKey wk, Canvas canvas, View view, Model model, SegmentKey modelKey);
	void Bloom_Silhouette(WindowKey wk, Canvas canvas, View view, Model model, SegmentKey modelKey);
	void Database_Search(WindowKey wk, Canvas canvas, View view, Model model, SegmentKey modelKey);
	void Exchange_Publish(WindowKey wk, Canvas canvas, View view, Model model, SegmentKey modelKey);
	void Hidden_Line(WindowKey wk, Canvas canvas, View view, Model model, SegmentKey modelKey);
	void Hidden_Line_Advanced(WindowKey wk, Canvas canvas, View view, Model model, SegmentKey modelKey);
	void Image_Background(WindowKey wk, Canvas canvas, View view, Model model, SegmentKey modelKey);
	void Image_Io(WindowKey wk, Canvas canvas, View view, Model model, SegmentKey modelKey);
	void Image_Output(WindowKey wk, Canvas canvas, View view, Model model, SegmentKey modelKey);
	void Mask_Transforms(WindowKey wk, Canvas canvas, View view, Model model, SegmentKey modelKey);
	void Meshes(WindowKey wk, Canvas canvas, View view, Model model, SegmentKey modelKey);
	void Quickmoves(WindowKey wk, Canvas canvas, View view, Model model, SegmentKey modelKey);
	void Render_Modes(WindowKey wk, Canvas canvas, View view, Model model, SegmentKey modelKey);
	void Segment_Attributes(WindowKey wk, Canvas canvas, View view, Model model, SegmentKey modelKey);
	void Sub_Shell_Attributes(WindowKey wk, Canvas canvas, View view, Model model, SegmentKey modelKey);
	void Spotlight(WindowKey wk, Canvas canvas, View view, Model model, SegmentKey modelKey);
	void Textures(WindowKey wk, Canvas canvas, View view, Model model, SegmentKey modelKey);
    void Shell_Attributes(WindowKey wk, Canvas canvas, View view, Model model, SegmentKey modelKey);
    void Priority(WindowKey wk, Canvas canvas, View view, Model model, SegmentKey modelKey);
    void Interpolation(WindowKey wk, Canvas canvas, View view, Model model, SegmentKey modelKey);
    void Exchange_PMI_Highlighting(WindowKey wk, Canvas canvas, View view, Model model, SegmentKey modelKey);
    void Exchange_Component_Highlighting(WindowKey wk, Canvas canvas, View view, Model model, SegmentKey modelKey);
    void Custom_Event(WindowKey wk, Canvas canvas, View view, Model model, SegmentKey modelKey);
    void Conditional_Styles_And_Includes(WindowKey wk, Canvas canvas, View view, Model model, SegmentKey modelKey);
    void Hardcopy_Export(WindowKey wk, Canvas canvas, View view, Model model, SegmentKey modelKey);
    
};

class Test
{
public:
    Test() : testID(-1), testName("")
    {}
    Test(int ID, UTF8 name) : testID(ID), testName(name)
    {}
    
    inline friend bool operator==(const Test & t1, const Test & t2);

    int testID;
    UTF8 testName;

};

bool operator==(const Test & t1, const Test & t2)
{
    return (t1.testName == t2.testName);
}

#endif /* defined(__hps_samples_osx__SamplesOSX__) */
